global interp_name
#puts "Loading interface code for $interp_name"

### default setup
learn -off
indifferent-selection -random

foreach i [io -list -input] {
   io -delete -input $i
}
io -add -input manageInputLink

foreach i [io -list -output] {
   io -delete -output $i
}
io -add -output manageOutputLink output-link

proc manageInputLink {mode} {
   global ioID interp_name tsiAgentStats

#    puts "manageInputLink $mode		(begin)"
   switch $mode {
      top-state-just-created {
	  output-strings-destination -push -append-to-result
	  set topStateID [lindex [wmes {(* ^superstate nil)}] 1]
	  set ioID [lindex [wmes "($topStateID ^io *)"] 3]
	  ## remove the trailing parenthesis
	  set ioID [string trimright $ioID ")"]
	  output-strings-destination -pop
	  setUpInputLink $ioID

      }
      normal-input-cycle {

	  set time1 [clock clicks]

	 updateInputLink
	 
	  set time2 [clock clicks]

	  set taken [expr (1.0*($time2 - $time1))/$tsiAgentStats(clicksPerSecond)]

	  incr tsiAgentStats(inputCycles)

	  set tsiAgentStats(inputTime) \
	     [expr $tsiAgentStats(inputTime) + $taken]

      }
      top-state-just-removed {

         removeInputLink


      }
   }
#    puts "manageInputLink $mode		(end)"
}

proc manageOutputLink {mode outputs} {
   global ioID outputLinkID tsiAgentStats
    
    set begin [clock clicks]
#    puts "manageOutputLink $mode     (begin)"

   switch $mode {
      added-output-command {
         set outputLinkID [getOutputValue $outputs $ioID "output-link"]
	 set walkID [getOutputValue $outputs $outputLinkID "move"]
         set jumpID [getOutputValue $outputs $outputLinkID "jump"]
         
         ## SB May 02 1997
         ## walkdir is actually used to walk the eater one step; movement is
         ## for one step and then stops.
          if {$walkID != ""} {
	     set walkdir [getOutputValue $outputs $walkID "direction"]
	      set isComplete [getOutputValue $outputs $walkID "status"]
 
	     if {$walkdir == "" || $isComplete == "complete" } {
		 
#		 puts "CANNOT FIND WALK DIRECTION OR ALREADY APPLIED 1!!!"
	     } else {
		 setWalkDir $walkdir $walkID
#		 puts "WALK DIRECTION is $walkdir"
	     }
            # send $controlName "set eaterDir($interp_name) $walkdir"
         } else {
           if {$jumpID != ""} {
	       set jumpdir [getOutputValue $outputs $jumpID "direction"]
	       set isComplete [getOutputValue $outputs $jumpID "status"]

	       if { $jumpdir == "" || $isComplete == "complete" } {
#		   puts "CANNOT FIND JUMP DIRECTION OR ALREADY APPLIED 1!!!"
	       } else {
		   setJumpDir $jumpdir $jumpID
	       }
	      # send $controlName "set eaterDir($interp_name) $jumpdir"
            } 
   
         } 
      } 
      modified-output-command {
         set walkID [getOutputValue $outputs $outputLinkID "move"]
         set jumpID [getOutputValue $outputs $outputLinkID "jump"]
         ## SB May 02 1997
         ## walkdir is actually used to move the eater; movement is
         ## for one step and then stops.
         if {$walkID != ""} {
	     set walkdir [getOutputValue $outputs $walkID "direction"]
	     set isComplete [getOutputValue $outputs $walkID "status"]

	     if {$walkdir == "" || $isComplete == "complete"} {
#		 puts "CANNOT FIND WALK DIRECTION OR ALREADY APPLIED 2!!!"
#		 puts "WALK DIRECTION Is $walkdir"
	     } else {
		 setWalkDir $walkdir $walkID
#		 puts "WALK DIRECTION is $walkdir"
	     }
            # send $controlName "set eaterDir($interp_name) $walkdir"
         } else {
#	     puts "NO WALK DIR--------- Checking for JUMP"
           if {$jumpID != ""} {
	       set jumpdir [getOutputValue $outputs $jumpID "direction"]
	       set isComplete [getOutputValue $outputs $jumpID "status"]

	       if { $jumpdir == "" || $isComplete == "complete" } {
#		   puts "CANNOT FIND JUMP DIRECTION OR ALREADY APPLIED 2!!!"
	       } else {
		   setJumpDir $jumpdir $jumpID
	       }
	      # send $controlName "set eaterDir($interp_name) $jumpdir"
            } 
	 }
      }
   }

    set end [clock clicks]

    set taken [expr (1.0*($end - $begin))/ $tsiAgentStats(clicksPerSecond)]

    incr tsiAgentStats(outputCycles)

    set tsiAgentStats(outputTime) \
       [expr $tsiAgentStats(outputTime) + $taken]

#    puts "manageOutputLink $mode     (end)"
}

proc getOutputValue {outputs id attr} {
   foreach wme $outputs {
      if {(($id == "") || [string match $id [lindex $wme 0]]) && \
          (($attr == "") || [string match $attr [lindex $wme 1]])} {
         return [lindex $wme 2]
      }
   }
   return ""
}

